/* SIMPLE - Simple Is a Macro Processing Language Element */
/* Copyright (c) 1998 David A. Madore (david.madore@ens.fr) */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
 * the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "simple.h"

typedef struct token_dict_entry {
  token tk;
  char *name;
} token_dict_entry;

token_dict_entry builtins_dict[] = {
  {BI_VOID,"void"},
  {BI_IDENTITY,"id"},
  {BI_OUTPUT,"out"},
  {BI_DEFINE,"def"},
  {BI_INCLUDE,"include"},
  {BI_TOKENIZE,""}, /* To tokenize a string, just use @@whatever" */
  {BI_QUOTE,"quote"},
  {BI_IF,"if"},
  {BI_HEAD,"head"},
  {BI_TAIL,"tail"},
  {0,NULL}
};

token_dict_entry *user_dict = NULL;
int user_dict_len=0;

static int firstfree = FIRST_USER_COMMAND+1;

token
identifycommand(char *name)
{
  int i,j,k;
  k=1; j=0;
  for (i=0;name[i];i++) {
    if ((name[i]>='0')&&(name[i]<='9'))
      j=10*j+(name[i]-'0');
    else {
      k=0;
      break;
    }
  }
  if (k&&(i>0)) {
    if ((j<0)||(j>=MAX_PARAM))
      fatal(0,"Sorry, buddy, that here parameter number is too high.");
    return FIRST_PARAM+j;
  }
  for (i=0;builtins_dict[i].tk;i++) {
    if (strcmp(name,builtins_dict[i].name)==0)
      return builtins_dict[i].tk;
  }
  for (i=0;i<user_dict_len;i++) {
    if (strcmp(name,user_dict[i].name)==0)
      return user_dict[i].tk;
  }
  if ((user_dict=realloc(user_dict,(++user_dict_len)*sizeof(token_dict_entry)))
      ==NULL)
    fatal(0,"Out of memory!");
  user_dict[user_dict_len-1].tk=firstfree++;
  user_dict[user_dict_len-1].name=malloc(strlen(name)+1);
  strcpy(user_dict[user_dict_len-1].name,name);
  return user_dict[user_dict_len-1].tk;
}
