/* SIMPLE - Simple Is a Macro Processing Language Element */
/* Copyright (c) 1998 David A. Madore (david.madore@ens.fr) */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
 * the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <unistd.h>
#include <getopt.h>
#include <stdlib.h>

#include "simple.h"

static const struct option long_options[] = {
  {"help",no_argument,NULL,'h'},
  {"version",no_argument,NULL,'V'},
  {"copying",no_argument,NULL,'c'},
  {NULL,0,NULL,0}
};

void
main(int argc,char **argv)
{
  int opt;
  while ((opt=getopt_long(argc,argv,"hVc",long_options,NULL))!=EOF) {
    switch (opt) {
    case 'h':
      fprintf(stderr,"Usage is %s [OPTIONS]...\n",argv[0]);
      fprintf(stderr,"\
Valid options are:
  -h, --help                   display this help and exit\n\
  -V, --version                display version information and exit\n\
  -c, --copying                display copying information and exit\n\
");
      exit(EXIT_SUCCESS);
      break;
    case 'V':
      fprintf(stderr,PRODUCTSTRING ", version " VERSIONSTRING
	      " (" DATESTRING ")\n");
      exit(EXIT_SUCCESS);
      break;
    case 'c':
      fprintf(stderr,"\
This program is free software; you can redistribute it and/or\n\
modify it under the terms of the GNU General Public License\n\
as published by the Free Software Foundation; either version\n\
2 of the License, or (at your option) any later version.\n\
\n\
This program is distributed in the hope that it will be useful,\n\
but WITHOUT ANY WARRANTY; without even the implied warranty\n\
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See\n\
the GNU General Public License for more details.\n\
\n\
You should have received a copy of the GNU General Public License\n\
along with this program; if not, write to the Free Software\n\
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.\n\
");
      exit(EXIT_SUCCESS);
      break;
    default:
      fprintf(stderr,"Type %s --help for a list of valid options.\n",argv[0]);
      exit(EXIT_FAILURE);
      break;
    }
  }
  if (argc==optind) {
    pushinputfile("-");
  } else for (;optind<argc;argc--) {
    pushinputfile(argv[argc-1]);
  }
  expandinput();
}
