/* SIMPLE - Simple Is a Macro Processing Language Element */
/* Copyright (c) 1998 David A. Madore (david.madore@ens.fr) */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
 * the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define PRODUCTSTRING "SIMPLE"
#define VERSIONSTRING "1.0.2"
#define DATESTRING "08JAN98"

typedef int token;

typedef struct token_list {
  token *l;
  int size;
  int allsize;
} token_list;

#define FIRST_SPECIAL 256

#define END_ARGLIST 257
#define NEXT_ARG 258
#define OPEN_QUOTE 273
#define CLOSE_QUOTE 274
#define QUOTE_NEXT 275

#define FIRST_PARAM 384
/* Number of parameters is thus effectively limited to 127 - sorry */
#define MAX_PARAM (FIRST_COMMAND-FIRST_PARAM-1)

#define FIRST_COMMAND 512

#define BI_IDENTITY 513
#define BI_VOID 514
#define BI_OUTPUT 515
#define BI_DEFINE 516
#define BI_INCLUDE 517
#define BI_TOKENIZE 518
#define BI_QUOTE 519
#define BI_IF 520
#define BI_HEAD 521
#define BI_TAIL 522

#define FIRST_USER_COMMAND 1024

void fatal(char internal,char *fmt, ...);

void pushinputfile(char *name);

token identifycommand(char *name);

token inputtoken(void);

void outputtoken(token tk);

void expandinput(void);

void callbuiltin(token_list *expansion,token tk,int argc,token_list *argv);

void calluser(token_list *expansion,token tk,int argc,token_list *argv);
